# Compte GitLab

Pour utiliser GitLab chaque personne pourra se créer un compte qui aura différents droits et différents paramètres.

Chaque compte est unique et authendifié par l'identifiant du compte correspondant à une chaîne de caractères sans espaces (pour moi c'est *ArmandBahi*) que l'on voit affiché sous notre nom, après le @; tout compte possède également une adresse mail unique pour s'identifier.

**Il est très important que les données que vous écrirez sur ces deux champs correspondent à celles que vous allez utiliser localement avec GitKraken etc..**

Je vais ci-après vous détailler les sections les plus importantes, pour éditer ces paramètres, il suffit de cliquer sur son profil (bouton en haut à droite) puis aller sur **Settings**

![compte_1](../images/compte_1.jpg)

## 1. Profile

Dans la partie profile nous pouvons éditer notre adresse mail, notre photo etc...

![compte_2](../images/compte_2.jpg)

GitLab n'est pas entièrement traduit en Français et parfois on peut se perdre avec les termes techniques, mon conseil si vous arrivez à lire l'anglais technique est de passer l'interface en anglais.

![compte_3](../images/compte_3.jpg)

## 2. Notifications

GitLab va vous envoyer des notifications par email en fonction de votre implication dans les différents projets, vous pouvez paramétrer le niveau de notifications que nous allez recevoir directement dans cette section.

![compte_4](../images/compte_4.jpg)

## 3. SSH keys

Les clés SSH font partie intégrante de l'utilisation de Git en général car contrairement à SVN, git ne permet pas d'enregistrer ses mots de passe pour des raisons de sécurité. Si vous l'utilisez tel quel git vous demandera votre mot de passe à chaque fois que vous voudrez envoyer un fichier sur le serveur.

Pour ne pas devoir taper votre mot de passe à chaque fois, vous devrez créer une clé SSH et la lier à votre compte GitLab.

### 3.1. Générer une clé SSH

Pour générer une clé SSH il y a différentes solutions, l'une d'entre elles et la plus simple celons moi est d'utiliser GitKraken.

Pour cela il faut cliquer sur le bouton en situé à droite de votre profil, puis *Preferences>Authentification*, alors GitKraken permet de générer une clé SSH qu'il utilisera.

Une fois ceci fait deux fichiers auront étés générés id_rsa qui correspond à la clé privée **que vous ne devez communiquer sous aucun prétexte** et id_rsa.pub qui est la clé publique que vous fournirez aux différents services.

![compte_ssh_gitkraken](../images/compte_ssh_gitkraken.jpg)

### 3.2. Enregistrer la clé

Une fois que vous avez généré votre paire de clés, copiez le contenu de la clé publique (id_rsa.pub) et collez-le dans le champ Key, enfin donnez un nom à votre clé (exemple : Ordinateur Armand) puis ajoutez-la.

![compte_5](../images/compte_5.jpg)

Vous pouvez maintenant utiliser GitKraken sans taper votre mot de passe à nouveau.

## 4. Preferences

Ici vous pourrez modifier la couleur de votre interface et surtout décider de quelle page s'affiche quand vous arrivez sur GitLab.

![compte_6](../images/compte_6.jpg)

J'ai moi même décidé d'afficher **Your Groups** en page d'accueil de manière à arriver sur la liste des groupes dans lesquels je suis impliqué.

![compte_7](../images/compte_7.jpg)
